// Copyright (c) 2006 Google Inc.
// All rights reserved
// 
// This file is part of the Google Desktop SDK and may be freely copied and used.
// To download the latest version of the SDK please visit 
// http://desktop.google.com/

var FeedEntries = new Array();
var MAX_SMS_MESSAGE_LENGTH = 150;
var MAX_SMS_MESSAGE_REMITTANT_LENGTH = 20;
var MAX_EMAILS_SHOWN = 4;
var isFirstPhoneEdit = true;
function setupTimer()
{
	view.setTimeout(fetchNewEmail, 20000);
	view.onopen="";
}

function fetchNewEmail() 
{ 
  try
  {
      loadFeeds("https://mail.google.com/mail/feed/atom?" + Math.floor(Math.random()*1000000)); 
  } 
  catch (e)
  {
  	gadget.debug.error(e);
  }
  try
  {
	//If there's a phone number, forward all;
	phoneCheck = /\d{6,12}/;
	if(phoneCheck.test(txtPhoneNumber.value))
	{
		sendAllSMS();
	} 
	else if(FeedEntries.length>0 && txtPhoneNumber.value.length>0 && txtPhoneNumber.value != TYPE_PHONE_HERE)
	{
		alert(WRONG_PHONE_NUMBER);
	}
  }
  catch (e)
  {
  	gadget.debug.error(e);
  }
  lblNoNewMail.visible = (FeedEntries.length == 0);
  view.setTimeout(fetchNewEmail, 60000);
} 

function sendAllSMS()
{
	for(ji=0; ji<FeedEntries.length; ji++)
	{
		if(!FeedEntries[ji].smsSentAlready) sendSms(FeedEntries[ji]);
	}
}

var xmlRequest;
function loadFeeds(url) 
{ 
  xmlRequest = new XMLHttpRequest(); 
  xmlRequest.onreadystatechange = processFeedQuery; 
  xmlRequest.open("GET", url, false); 
  xmlRequest.send(null); 
  processFeedQuery();
} 

function processFeedQuery() 
{ 
  if (xmlRequest.readyState == 4) 
  {
	  if (xmlRequest.Status == 200) 
	  { 
	      var doc = new DOMDocument(); 
	      doc.loadXML(xmlRequest.responseText); 
	      entryList = doc.getElementsByTagName("entry"); 
	      
	      for(i=0; i< entryList.length && i<MAX_EMAILS_SHOWN; i++)
	      {
	      	entry = new FeedEntry();
	      	
	      	//Copy values from atom entry to the FeedEntry object
	      	entry.id = entryList[i].getElementsByTagName("id")[0].firstChild.nodeValue;
	      	
	      	if(entryList[i].getElementsByTagName("title")[0] != null
	      		&& entryList[i].getElementsByTagName("title")[0].firstChild != null)
	      		entry.title = unescape( entryList[i].getElementsByTagName("title")[0].firstChild.nodeValue );
	      	
	      	if(entryList[i].getElementsByTagName("summary")[0] != null
	      		&& entryList[i].getElementsByTagName("summary")[0].firstChild != null)
	      		entry.summary = unescape( entryList[i].getElementsByTagName("summary")[0].firstChild.nodeValue );
	      	
	      	entry.date = entryList[i].getElementsByTagName("issued")[0].firstChild.nodeValue;	      	
	      	authorName = entryList[i].getElementsByTagName("author")[0].getElementsByTagName("name")[0].firstChild.nodeValue;
	      	authorEmail = entryList[i].getElementsByTagName("author")[0].getElementsByTagName("email")[0].firstChild.nodeValue;
	      	entry.from = authorName + " [" + authorEmail + "]";

		//Update UI elements
	      	view.children.item("lblEmailEntry" + (i+1)).innerText = entry.from + ". " + entry.title;
	      	
	      	//Add entry if it's new
	      	if( isNewEntry(entry) )
	      	{
	      		insertEntry(entry);
	      	}
	      	
	      }
	      
	      // Clear unused UI elements 
	      for(j=i; j<MAX_EMAILS_SHOWN; j++)
	      {
	      	try
	      	{
	      		FeedEntries.splice(i, 1);
	      	} catch (e) {}
	      	view.children.item("lblEmailEntry" + (j+1)).innerText="";
	      }
	  } 
	  else 
	  { 
	  	gadget.debug.error("There was a problem retrieving the XML data:\n" 
			+ xmlRequest.statusText
			+ "\n" + xmlRequest.Status
			+ "\n" + xmlRequest.responseText);
	  } 
   }
} 


function entryClick(entryIndex)
{
	if(entryIndex > FeedEntries.length) return false;
	emailEntry = FeedEntries[entryIndex];
	if(emailEntry != null) openEntryDetails(emailEntry);
}
function openEntryDetails(entryDetails)
{
	  var htmlDetailsView = new DetailsView();
	  htmlDetailsView.html_content = true;

	htmlDetailsViewHtml = "<html><body style=\"font:12px 300 Arial,sans-serif\">"
	+ "<p><b>From:</b> " + entryDetails.from
	+ "<br><p>" + entryDetails.summary
	+ "</p></body></html>";

	  htmlDetailsView.setContent("", undefined, htmlDetailsViewHtml, false, 0);

	pluginHelper.showDetailsView(htmlDetailsView, entryDetails.title, 
    	gddDetailsViewFlagToolbarOpen, onDetailsViewFeedback);
}

function onDetailsViewFeedback(detailsViewFlags) {
  if (detailsViewFlags == gddDetailsViewFlagNone) {
    // User closed the details view
  } else if (detailsViewFlags == gddDetailsViewFlagToolbarOpen) {
    // User clicked on the title of the details view
  }
}
    
function isNewEntry(entryToCompare)
{
	for(ki=0; ki<FeedEntries.length; ki++)
	{
		if(FeedEntries[ki].id == entryToCompare.id) return false;
	}
	return true;
}

function insertEntry(entryToInsert)
{
	for(kj = Math.min(FeedEntries.length, MAX_EMAILS_SHOWN);kj>0;kj--)
	{
		FeedEntries[kj] = FeedEntries[kj-1];
	}
	FeedEntries[0] = entryToInsert;
}

var cookieVal = "";
var cookieDate = new Date();
function sendSms(entryToSend)
{
	
	
	xmlRequestSms1 = new XMLHttpRequest(); 

	currentDate = new Date();	
	if(currentDate - cookieDate > 15*60*1000 || cookieVal=="")
	{
		// Send a GET request to get the session cookie
		xmlRequestSms1.open("GET", "http://www.telcel.com.mx/menes/envio-mensajes.jsp", false); 
		xmlRequestSms1.setRequestHeader("Accept-Language", "en-us,es-mx;q=0.5");
		xmlRequestSms1.setRequestHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322)");
		xmlRequestSms1.send(null); 
		  if (xmlRequestSms1.readyState == 4) 
		  {
			  if (xmlRequestSms1.Status == 200) { 
				cookieVal1 = xmlRequestSms1.getResponseHeader("Set-Cookie").split(";")[0];
				if(cookieVal1 != "") cookieVal = cookieVal1;
				cookieDate = new Date();
				gadget.debug.trace("Cookie: " 
					+ cookieVal);
			  }
			  else 
			  { 
				gadget.debug.error("There was a problem retrieving the XML data:\n" 
					+ xmlRequestSms1.statusText
					+ "\n" + xmlRequestSms1.Status
					+ "\n" + xmlRequestSms1.responseText);

			  } 
		   }
	}
	
	
	// If we could not get the session cookie, 
	// posting the message will fail, so we don't even try.
	if(cookieVal == null || cookieVal == "") return;
	
	// Send a POST request to send SMS
	   postData ="";
	   postData += "tel1=" + txtPhoneNumber.value;
	   	postData += "&mensaje=" + escape(entryToSend.toSmsMessage());
	   	postData += "&nomtel=" + "";
		postData += "&" + "tel2=&tel3=&tel4=&tel5=&tel6=&tel7=&tel8=&hora1=1&hora2=2&minuto1=0&minuto2=0&nulo=&mes=&dia=&hora=&minutos=&fh=";
	xmlRequestSms1.open("POST", "http://www.telcel.com.mx/menes/servlet/mensajes_unos_n", false); 
	xmlRequestSms1.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	xmlRequestSms1.setRequestHeader("Accept-Language", "en-us,es-mx;q=0.5");
	xmlRequestSms1.setRequestHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322)");
	xmlRequestSms1.setRequestHeader("Pragma", "no-cache");
	xmlRequestSms1.setRequestHeader("Content-Length", postData.length);
	xmlRequestSms1.setRequestHeader("Referer", "http://www.telcel.com.mx/menes/envio-mensajes.jsp");
	xmlRequestSms1.setRequestHeader("Cookie", cookieVal);
	
  	xmlRequestSms1.send(postData); 
  	if (xmlRequestSms1.readyState == 4) 
	  {
		  if (xmlRequestSms1.Status == 200) 
		  { 
		  	entryToSend.smsSentAlready = true;
			gadget.debug.trace("SMS sent: " + entryToSend.toSmsMessage());
		  }
		  else 
		  { 
			gadget.debug.error("There was a problem retrieving the XML data:\n" 
				+ xmlRequestSms1.statusText
				+ "\n" + xmlRequestSms1.Status
				+ "\n" + xmlRequestSms1.responseText);
		  } 
	   }
  	
}

function noLetters()
{
	if(view.event.srcElement.name == "txtPhoneNumber" )
	{
		if(isFirstPhoneEdit) 
		{
			txtPhoneNumber.value = "";
			isFirstPhoneEdit = false;
		}
		var keynum;
		var keychar;
		var numcheck;
		if(view.event) // IE
		{
			keynum = view.event.keyCode;
		}
		keychar = String.fromCharCode(keynum);
		numcheck = /\d/;
		view.event.returnValue = numcheck.test(keychar);
	}
}


/**
* Class FeedEntry
* A container of an email summary.
*/
function FeedEntry() 
{
	this.smsSentAlready = false;
	this.from = "";
	this.summary = "";
	this.title = "";
	this.date = "";
	this.id = "";
}

FeedEntry.prototype.toString = function()
{
	return  "ID=" + this.id + "\n"
		+ "From=" + this.from + "\n"
		+ "Title=" + this.title + "\n"
		+ "Summary=" + this.summary + "\n" 
		+ "Date=" + this.date;
}


FeedEntry.prototype.toSmsMessage = function()
{
	var re = new RegExp("\&nbsp\;", "gim");
	var re0 = new RegExp("<br>", "gim");
	var re1 = new RegExp("\&.{1,6}\;", "gim");
	var re2 = new RegExp("[^A-Z0-9 _\[\]\@-]+", "gim");
	msg = this.title.replace(re0, " ").replace(re, " ").replace(re1, "?").replace(re2, "?") 
		+ ": " + this.summary.replace(re0, " ").replace(re, " ").replace(re1, "?").replace(re2, "?");
	remittant = this.from;
	if(msg.length + remittant.length + 2 > MAX_SMS_MESSAGE_LENGTH)
	{
		remittant = remittant.substring(0, Math.min(MAX_SMS_MESSAGE_REMITTANT_LENGTH, remittant.length));
		msg = msg.substring(0, Math.min(MAX_SMS_MESSAGE_LENGTH - remittant.length - 2, msg.length));
	}
	msg += ". " + remittant;
	return msg;
}

FeedEntry.prototype.toUiXml = function(x, y)
{
	return            "<label width=\"70\" height=\"20\" x=\"" + x + "\" y=\"" + y + "\" background=\"#FFFFFF\" color=\"#000000\">" + this.from 
		+ "</label><label width=\"70\" height=\"20\" x=\"" + (x += 70) + "\" y=\"" + y + "\" background=\"#FFFFFF\" color=\"#000000\">" + this.title 
		+ "</label><label width=\"70\" height=\"20\" x=\"" + (x += 70) + "\" y=\"" + y + "\" background=\"#FFFFFF\" color=\"#000000\">" + this.summary 
		+ "</label><label width=\"70\" height=\"20\" x=\"" + (x += 70)+ "\" y=\"" + y + "\" background=\"#FFFFFF\" color=\"#000000\">" + this.date 
		+ "</label>";
}